;==============================================================================
; Kurts - Extras - for the phoenix on an Arc32
;==============================================================================

;==============================================================================
; Defines and Variables
;==============================================================================
#ifndef BASICATOMPRO28 ; no room on a bap28 for any of this...
#ifndef HSP_DEBUG
HSP_DEBUG	con	 1
#endif

_TM_szIn	var	byte(50)		; try to reuse the same memory
_TM_iszIn	var	byte




;==============================================================================
; [InitIdleProc] Init the terminal monitor
;==============================================================================
InitIdleProc:
	; setup initial values for where to start dumping from and count

	gosub IdleProcShowCmdList
	gosub IdleProc
	return

;==============================================================================
; [TerminalMonitorInit] Init the terminal monitor
;==============================================================================
IdleProcShowCmdList:
		hserout HSP_DEBUG, [13, 13, "Phoenix-Arc32 keyboard monitor",13,|
					 	"  T <n> - Set or show debug Trace level", 13, |
					 	" : "]
	
	return



;==============================================================================
; [TerminalMonitor]Terminal monitor - Since on the Arc32 S_IN/S_OUT are on a hardware
; serial port, there is almost no overhead for me to monitor it for inputs.  as
; such might as well add in some stuff from external programs I have.  For now
; will add Sequence Downloader, EEPROM Dump, and set debug on and off...
;==============================================================================

IdleProc:
	if (hserinnext 0x81) = -1 then _TM_NoInput
	hserin HSP_DEBUG, [str _TM_szIn\80\13] 
	
	if _TM_szIn(0) = 13 then
		gosub IdleProcShowCmdList

	elseif (_TM_szIn(0) = "t") or (_TM_szIn(0) = "T")	; The user wants to see or set the debug level
		if _TM_szIn(1) <> 13 then
			_TM_iszIn = 1

			gosub ExtractNum[], wDebugLevel
		endif
		hserout HSP_DEBUG, [13, "Current Debug Level: 	", dec wDebugLevel, "(", hex wDebugLevel, ")", 13]
	endif
	hserout HSP_DEBUG, [": "]
_TM_NoInput:
	return

;==============================================================================


;------------------------------------------------------------------------------
; Extract Number from input line
;------------------------------------------------------------------------------
wNum		var	word
fContinue	var	bit

ExtractNum:
	wNum = 0
	; skip any leading blanks...
	while (_TM_szIn(_TM_iszIn) = " ")
		_TM_iszIn = _TM_iszIn + 1
	wend

	; lets parse the strings to see if we have a start address or not...
	if (_TM_szIn(_TM_iszIn) = "0") and ((_TM_szIn(_TM_iszIn+1) = "x") or (_TM_szIn(_TM_iszIn+1) = "X")) then
		; hex number 
		_TM_iszIn = _TM_iszIn+2
		fContinue = 1
		do 
			if (_TM_szIn(_TM_iszIn) >= "0") and (_TM_szIn(_TM_iszIn) <= "9") then
				wNum = wNum * 16 + _TM_szIn(_TM_iszIn)-"0"
				_TM_iszIn = _TM_iszIn + 1
			elseif (_TM_szIn(_TM_iszIn) >= "a") and (_TM_szIn(_TM_iszIn) <= "f")
				wNum = wNum * 16 + _TM_szIn(_TM_iszIn)-"a"+10
				_TM_iszIn = _TM_iszIn + 1
			elseif (_TM_szIn(_TM_iszIn) >= "A") and (_TM_szIn(_TM_iszIn) <= "F")
				wNum = wNum * 16 + _TM_szIn(_TM_iszIn)-"A"+10
				_TM_iszIn = _TM_iszIn + 1
			else 
				fContinue = 0
			endif
		while(fcontinue)
	else
		; assume decimal number
		fContinue = 1
		do 
			if (_TM_szIn(_TM_iszIn) >= "0") and (_TM_szIn(_TM_iszIn) <= "9") then
				wNum = wNum * 10 + _TM_szIn(_TM_iszIn)-"0"
				_TM_iszIn = _TM_iszIn + 1
			else 
				fContinue = 0
			endif
		while(fcontinue)
	endif

	return wNum

